/*	Copyright (C) 2003-2015 Free Electron Organization
	Any use of this software requires a license.  If a valid license
	was not distributed with this file, visit freeelectron.org. */

/** @file */

#ifndef __alembic_SurfaceAccessibleAbc_h__
#define __alembic_SurfaceAccessibleAbc_h__

namespace fe
{

/**************************************************************************//**
    @brief Alembic Surface Binding

	@ingroup alembic
*//***************************************************************************/
class FE_DL_EXPORT SurfaceAccessibleAbc:
	public SurfaceAccessibleJoint
{
	public:
								SurfaceAccessibleAbc(void)					{}
virtual							~SurfaceAccessibleAbc(void)					{}

								//* as SurfaceAccessibleI

virtual	BWORD					load(String a_filename,
										sp<Catalog> a_spSettings);

	private:

	class FileContext: public Component
	{
		public:
						FileContext(void);
	virtual				~FileContext(void);

			Alembic::AbcGeom::IArchive	m_archive;
	};

		enum	Mode
				{
					e_scan,
					e_mesh,
					e_curve,
					e_joint
				};

		BWORD					setContext(String a_filename);

		void					visit(Alembic::AbcGeom::IObject a_iObj);

		void					visitProperty(
										Alembic::AbcGeom::IScalarProperty
										a_properties,
										String a_indent,
										String a_parentPath,String a_path);
		void					visitProperty(
										Alembic::AbcGeom::IArrayProperty
										a_properties,
										String a_indent,
										String a_parentPath,String a_path,
										Alembic::AbcGeom::GeometryScope
										a_geometryScope);
		void					visitProperty(
										Alembic::AbcGeom::ICompoundProperty
										a_properties,
										String& a_rIndent,
										String a_parentPath,String a_path);
		void					visitProperties(
										Alembic::AbcGeom::ICompoundProperty
										a_properties,
										String& a_rIndent,
										String a_parentPath,String a_path);

		BWORD							m_refMode;
		Real							m_fps;
		Real							m_minStep;
		Mode							m_mode;
		I32								m_xformCount;
		I32								m_meshCount;
		I32								m_curveCount;

		sp<FileContext>					m_spContext;

		String							m_filename;
		SpatialTransform				m_refWorld;

		Array<String>					m_pathArray;
		Array<String>					m_matchArray;
		Array<SpatialVector>			m_pointArray;
		Array<SpatialVector>			m_pointRefArray;
		Array<SpatialVector>			m_colorArray;
		Array<SpatialVector>			m_normalArray;
		Array<SpatialVector>			m_uvArray;
		Array<I32>						m_uvLookupArray;
		Array<I32>						m_vertCountArray;
		Array<I32>						m_vertIndexArray;
		Array<Real>						m_radiusArray;
		Array< Array<I32> >				m_primVerts;

		std::map<String,I32>			m_firstFaceMap;

		Alembic::AbcGeom::GeometryScope	m_colorScope;
		Alembic::AbcGeom::GeometryScope	m_uvScope;
};

} // namespace

#endif /* __alembic_SurfaceAccessibleAbc_h__ */
