/*	Copyright (C) 2003-2015 Free Electron Organization
	Any use of this software requires a license.  If a valid license
	was not distributed with this file, visit freeelectron.org. */

/** @file */

#include "network/network.h"

#define LISTENQ		5
#define SERV_PORT	7876

int main(void)
{
	fe::UnitTest unitTest;

	try
	{
		feLogGroup("network","test echo server\n");

		fe::sp<fe::Socket>		listener(new fe::Socket);
		fe::sp<fe::Socket>		connection(new fe::Socket);
		fe::SockAddr			server_addr;
		fe::SockAddr			client_addr;

		listener->openStream();
		server_addr.setPort(SERV_PORT);
		listener->bind(server_addr);
		listener->listen(LISTENQ);

		while(true)
		{
			feLogGroup("network","waiting...\n");
			connection = listener->accept(client_addr);

			feLogGroup("network","connected: %s %d\n", client_addr.hostname().c_str(),
				client_addr.port());

			long size;
			connection->read((void *)&size, 4);
			size = ntohl(size);
			char *buffer = new char[size];
			connection->read((void *)buffer, size);
			feLogGroup("network","[%s]\n", buffer);
			delete [] buffer;
		}
	}
	catch(fe::Exception &e)
	{
		e.log();
	}

	return unitTest.failures();
}


