#! /usr/bin/python

import sys

if len(sys.argv) < 2:
	print "Usage: " + sys.argv[0] + " [-frame FRAME] [-frames START END] [-options 'OPTION=\"STRING\"...'] FILES..."
	exit()

filenames = []
frameStart = 0
frameEnd = 0
options = ""
argCount = len(sys.argv)

surfaceOptions = { 0:{}, 1:{}, 2:{}, 3:{} }
surfaceCount = 0

argIndex = 1
while True:
	arg = sys.argv[argIndex]
	argIndex += 1

	if arg == "-frame":
		frame = int(sys.argv[argIndex])
		argIndex += 1

		frameStart = frame
		frameEnd = frame
	elif arg == "-frames":
		frameStart = int(sys.argv[argIndex])
		frameEnd = int(sys.argv[argIndex + 1])
		argIndex += 2
	elif arg == "-options":
		options = sys.argv[argIndex]
		argIndex += 1
	else:
		filenames += [ arg ]

		surfaceOptions[surfaceCount] = options
		surfaceCount += 1

	if argIndex >= argCount:
		break;

import pyfe

fe = pyfe.Context()
fe.manage("fexOperatorDL")
fe.manage("fexOpLabDL")

#surfaceNormalOp = fe.create("SurfaceNormalOp")
surfaceViewerOp = fe.create("SurfaceViewerOp")

surfaces = { 0:{}, 1:{}, 2:{}, 3:{} }

showing = False

frame = frameStart
frameInc = (frameStart != frameEnd)

while True:
	fe.setFrame(frame)

	# cache frames as used
	for surfaceIndex in range(4):
		if len(filenames) > surfaceIndex and filenames[surfaceIndex] != "":
			if not frame in surfaces[surfaceIndex]:
				filename = filenames[surfaceIndex].replace("$F", str(frame))
#					surfaceName = "model" + str(surfaceIndex) + ":" + str(frame)
				surfaceName = filename + ":" + str(frame)
				surfaces[surfaceIndex][frame] = fe.load(filename, surfaceName, surfaceOptions[surfaceIndex])

	# use None whenever frame is missing
	current = {}
	for surfaceIndex in range(4):
		if frame in surfaces[surfaceIndex]:
			current[surfaceIndex] = surfaces[surfaceIndex][frame]
#				current[surfaceIndex] = surfaceNormalOp(surfaces[surfaceIndex][frame])
		else:
			current[surfaceIndex] = None
		if current[surfaceIndex]:
			showing = True

	if current[0] or current[1] or current[2] or current[3]:
		surfaceViewerOp(current[0], current[1], current[2], current[3])

	if int(surfaceViewerOp["finished"]):
		exit()

	for key in surfaceViewerOp["keys"]:
		if key == "<":
			frame = frame - 1
		if key == ">":
			frame = frame + 1
		if key == " ":
			frameInc = not frameInc

	# WARNING not really thread safe
	surfaceViewerOp["keys"] = ""

	frame = frame + frameInc

	if frame > frameEnd and not showing:
		print "nothing viewable"
		break

	if frame > frameEnd:
		frame = frame + frameStart - frameEnd
	if frame > frameEnd:
		frame = frameEnd
	if frame < frameStart:
		frame = frame + frameEnd - frameStart
	if frame < frameStart:
		frame = frameStart
